angular.module('account', ['Api'])
  .controller('AccountCtrl', function ($scope, $rootScope, $http, $state, $stateParams, $ionicHistory, $cordovaCamera, $cordovaDialogs, $ionicLoading, $cordovaFile, $cordovaKeyboard, $cordovaFileTransfer, $timeout, $cordovaSQLite, Api) {

    $scope.api = new Api();

    /*$rootScope.$on('$stateChangeStart',
     function (event, toState, toParams, fromState, fromParams) {
     $scope.profilePic = window.localStorage.getItem("profilePic");
     $scope.profileName = window.localStorage.getItem("name");
     $scope.profileId = $rootScope.profileId;
     $scope.profileEmail = window.localStorage.getItem("email");
     $scope.balance = window.localStorage.getItem("balance");

     });*/

    if ($stateParams.state != "") {
      $scope.state = $stateParams.state;
    } else {
      $scope.state = 1;
    }

    $scope.platform = ionic.Platform.platform();

    if ($scope.state == 1) {
      $scope.header = "Profilom";
    } else {
      $scope.header = "Beállítások";
    }

    $rootScope.initAccount = function () {

      $scope.profilePic = $rootScope.profilePic;
      $scope.profileName = $rootScope.profileName;
      $scope.profileId = $rootScope.profileId;
      $scope.profileEmail = $rootScope.profileEmail;
      $scope.balance = $rootScope.actualBalance;

      $rootScope.accountInit = 1;

      if ($rootScope.isOnline) {
        if ($scope.state == 1) {
          $scope.checkForDownload();
        }
      } else {
        if (window.localStorage.getItem("timestamp") == null) {
          $cordovaDialogs.alert('Az első indításnál szükséges internetkapcsolat az adatbázis szinkronizálásához!', 'Hiba', 'OK');
        } else {
          $scope.openDB("sqlite");
        }
      }
    };

    $scope.back = function () {
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: false
      });
      $state.go('tab.account', {state: 1});
    };

    $scope.options = function () {
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: false
      });
      $state.go('tab.account', {state: 2});
    };

    $scope.dataURItoBlob = function (dataURI) {
      // convert base64 to raw binary data held in a string
      // doesn't handle URLEncoded DataURIs - see SO answer #6850276 for code that does this
      var byteString = atob(dataURI.split(',')[1]);

      // separate out the mime component
      var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0]

      // write the bytes of the string to an ArrayBuffer
      var ab = new ArrayBuffer(byteString.length);
      var ia = new Uint8Array(ab);
      for (var i = 0; i < byteString.length; i++) {
        ia[i] = byteString.charCodeAt(i);
      }

      // write the ArrayBuffer to a blob, and you're done
      var bb = new Blob([ab]);
      return bb;
    };

    $scope.addProfilePicture = function () {
      //alert("Upload profile picture...");
      if (!$rootScope.isOnline) {
        $scope.needInternet();
      } else {
        document.addEventListener("deviceready", function () {

          var source = Camera.PictureSourceType.PHOTOLIBRARY;

          $cordovaDialogs.confirm('Honnan szeretnél képet feltölteni?', 'Új profil fotó', ['Galéria', 'Kamera'])
            .then(function (buttonIndex) {
              // no button = 0, 'OK' = 1, 'Cancel' = 2

              switch (buttonIndex) {
                case 0:
                  return;
                case 1:
                  source = Camera.PictureSourceType.PHOTOLIBRARY;
                  break;
                case 2:
                  source = Camera.PictureSourceType.CAMERA;
                  break;
              }

              var options = {
                quality: 80,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: source,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                targetWidth: 200,
                targetHeight: 200,
                saveToPhotoAlbum: false,
                correctOrientation: true
              };

              $cordovaCamera.getPicture(options).then(function (imageData) {
                $ionicLoading.show();

                var image = $('.profilePic');
                image.src = "data:image/jpeg;base64," + imageData;

                //$rootScope.profilePic = imageData;

                // TODO:
                // Kép feltöltése majd URL beállítása

                var fileName = imageData.substr(imageData.lastIndexOf("/") + 1, (imageData.length - imageData.lastIndexOf("/")));

                var data = {
                  action:'avatar',
                  token: window.localStorage.getItem("token"),
                  avatar: image.src
                };

                $scope.api.uploadPhoto(conv(data), function (response) {
                  console.log(JSON.stringify(response));

                  $rootScope.profilePic = response.data.data.image;
                  $scope.profilePic = $rootScope.profilePic;
                  $('.profilePic').attr("src",$rootScope.profilePic);
                  window.localStorage.setItem("profilePic", $rootScope.profilePic);

                  $ionicLoading.hide();
                }, function (response){
                  $ionicLoading.hide();
                });

                function conv(obj) {
                  var str = [];
                  for(var p in obj)
                    str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                  return str.join("&");
                }


              }, function (err) {
                // error
                $ionicLoading.hide();
                console.log(JSON.stringify(err));

              });

            });

        }, false);
      }

    };

    $scope.logout = function () {
      $ionicLoading.show();
      if ($rootScope.isOnline) {
        $scope.api.get("logout", {token: window.localStorage.getItem("token")}, function (response) {
          window.localStorage.removeItem("token");
          window.localStorage.removeItem("name");
          window.localStorage.removeItem("email");
          window.localStorage.removeItem("profilePic");
          window.localStorage.removeItem("balance");
          window.localStorage.removeItem("id");

          var walkthrough = window.localStorage.getItem("walkthrough");
          var timestamp = window.localStorage.getItem("timestamp");

          window.localStorage.clear();
          window.localStorage.setItem("walkthrough", walkthrough);
          window.localStorage.setItem("timestamp", timestamp);
          $rootScope.actualBalance = null;
          $rootScope.profilePic = null;
          $rootScope.profileName = null;
          $rootScope.profileId = null;
          $rootScope.profileEmail = null;

          $rootScope.accountInit = 0;
          $rootScope.stopTimer();
          $rootScope.loginVisible = true;
          $state.go('login');
          $ionicLoading.hide();
        });
      } else {

        $cordovaDialogs.confirm('Biztosan ki szerertnél jelentkezni? Legközelebb csak aktív internet kapcsolat mellett tudsz belépni!', 'Figyelmezezés', ['Igen', 'Nem']).then(function (buttonIndex) {
          if (buttonIndex == 1) {
            window.localStorage.removeItem("token");
            window.localStorage.removeItem("name");
            window.localStorage.removeItem("email");
            window.localStorage.removeItem("profilePic");
            window.localStorage.removeItem("balance");
            window.localStorage.removeItem("id");

            var walkthrough = window.localStorage.getItem("walkthrough");
            var timestamp = window.localStorage.getItem("timestamp");

            window.localStorage.clear();
            window.localStorage.setItem("walkthrough", walkthrough);
            window.localStorage.setItem("timestamp", timestamp);

            $rootScope.actualBalance = null;
            $rootScope.profilePic = null;
            $rootScope.profileName = null;
            $rootScope.profileId = null;
            $rootScope.profileEmail = null;

            $rootScope.accountInit = 0;
            $rootScope.stopTimer();

            $rootScope.loginVisible = true;
            $state.go('login');
          }
        });
      }
    };

    $scope.changePassword = function () {
      if (!$rootScope.isOnline) {
        $scope.needInternet();
      } else {
        $cordovaDialogs.prompt("Adja meg az új jelszavát!", "Új jelszó", ["Vissza", "OK"], "").then(function (result) {
          var input = result.input1;
          // no button = 0, 'OK' = 1, 'Cancel' = 2
          var btnIndex = result.buttonIndex;

          if (btnIndex == 2) {
            if (input == "") {
              $cordovaDialogs.alert('A jelszó nem lehet üres!', 'Hiba', 'OK');
            } else {
              $scope.api.post("passwordChange", {
                token: window.localStorage.getItem("token"),
                password: input
              }, function (response) {
                if (response.data.success == false) {
                  $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
                } else {
                  $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');
                }
              });
            }
          }
        });
      }
    };

    $scope.uploadCouponCode = function () {
      if (!$rootScope.isOnline) {
        $scope.needInternet();
      } else {
        $cordovaDialogs.prompt("Adja meg a feltöltendő kuponkódot!", "Kuponkód feltöltés", ["Vissza", "OK"], "").then(function (result) {
          var input = result.input1;
          // no button = 0, 'OK' = 1, 'Cancel' = 2
          var btnIndex = result.buttonIndex;

          $cordovaKeyboard.close()

          if (btnIndex == 2) {
            if (input == "") {
              $cordovaDialogs.alert('A kuponkód nem lehet üres!', 'Hiba', 'OK');
            } else {
              $scope.api.post("addCoupon", {
                token: window.localStorage.getItem("token"),
                code: input
              }, function (response) {
                if (response.data.success == false) {
                  $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
                } else {
                  $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');

                  window.localStorage.setItem("balance", response.data.data.balance);
                  $scope.balance = window.localStorage.getItem("balance");
                  $rootScope.actualBalance = $scope.balance;
                }
              });
            }
          }
        });
      }
    };

    $scope.uploadWord = function () {
      if (!$rootScope.isOnline) {
        $scope.needInternet();
      } else {
        $cordovaDialogs.prompt("Adja meg a beküldeni kívánt szót!", "Szó beküldése", ["Vissza", "OK"], "").then(function (result) {
          var input = result.input1;
          // no button = 0, 'OK' = 1, 'Cancel' = 2
          var btnIndex = result.buttonIndex;

          $cordovaKeyboard.close();

          if (btnIndex == 2) {
            if (input == "") {
              $cordovaDialogs.alert('A szó nem lehet üres!', 'Hiba', 'OK');
            } else {
              $scope.api.post("newWord", {
                token: window.localStorage.getItem("token"),
                word: input
              }, function (response) {
                if (response.data.success == false) {
                  $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
                } else {
                  $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');
                }
              });
            }
          }
        });
      }
    };

    $scope.checkForDownload = function () {
      //document.addEventListener("deviceready", function () {
      //window.localStorage.removeItem("timestamp");
      var dir = "";
      if (ionic.Platform.isIOS()) {
        dir = cordova.file.documentsDirectory;
        //dir = "file:///Users/dominik/Library/Developer/CoreSimulator/Devices/2773DDBC-9D1D-406A-8B15-43C3E69B0E58/data/Containers/Data/Application/126D3456-DBEE-410A-879B-44BBB5863CEC/Documents/";
      } else {
        dir = cordova.file.applicationStorageDirectory + "/databases/";
        //dir = cordova.file.dataDirectory;
        //dir = cordova.file.externalDataDirectory;
      }

      $ionicLoading.show();
      var trustHosts = true;
      var options = {};

      $scope.api.get("download", {
        token: window.localStorage.getItem("token"),
        timestamp: window.localStorage.getItem("timestamp")
      }, function (response) {

        if (response.data.success == true) {
          if (response.data.data.success == true) {
            //Töröljük a meglévőt majd töltsük le az újat
            // $cordovaFile.removeFile(dir, window.localStorage.getItem("timestamp"));
            $scope.download(response.data.data.path, dir, response.data.data.name, options, trustHosts, response.data.data.timestamp);
          } else {
            if (!window.localStorage.getItem("timestamp")) {
              $scope.download(response.data.data.path, dir, response.data.data.name, options, trustHosts, response.data.data.timestamp);
            } else {
              console.log("Local Database is up to date!");
              $scope.openDB("sqlite");
            }
          }
        } else {
          $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
        }

      });

    };

    $scope.download = function (url, targetPath, filename, options, trustHosts, timestamp) {

      $scope.inProgress = true;
      $scope.downloadProgress = 0;

      filename = "sqlite";

      // DOWNLOAD FROM SERVER

      function success() {
        console.log("Succes moving file");
      }

      function error() {
        console.log("Error moving file");
      }

      //var url = $scope.api.url + "?token=" + window.localStorage.getItem("token") + "&action=download&timestamp=" + window.localStorage.getItem("timestamp");

      $cordovaFileTransfer.download(url, targetPath + filename, options, trustHosts)
        .then(function (result) {
          // Success!
          console.log("Success downloading");
          window.localStorage.setItem("sqlite", true);
          console.log("Local Database was updated!");

          window.localStorage.setItem("timestamp", timestamp);

          $scope.openDB(filename);

        }, function (err) {
          // Error
          console.log("Error downloading");
          console.log(JSON.stringify(err));
          $scope.inProgress = false;
          $ionicLoading.hide();
        }, function (progress) {
          $timeout(function () {
            $scope.downloadProgress = (progress.loaded / progress.total) * 100;
            //console.log($scope.downloadProgress);
          });
        });
    };

    $scope.openDB = function (name) {

      console.log("OPENING DB");

      db = window.sqlitePlugin.openDatabase({name: name, location: 0});
      $ionicLoading.hide();
    };

    $scope.needInternet = function () {
      $cordovaDialogs.alert('Ehhez a funkcióhoz internetkapcsolatra van szükség!', 'Hiba', 'OK');
    };

  });
