/* global TIMER */
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js

var db = null;

angular.module('starter', ['ionic', 'ionic-timepicker',"starter.views", "starter.directives", "ionic-datepicker", "starter.services", 'ngIOS9UIWebViewPatch', 'ngCordova', 'starter.controllers', 'SQL', 'Api'])

  .constant("TIMER", 60)

  .run(function ($ionicPlatform, $rootScope, $state, $ionicHistory, $timeout, $cordovaNetwork, TIMER, $cordovaStatusbar, $cordovaToast, Api) {
    $ionicPlatform.ready(function () {
      // Google Analytics
      //window.analytics.startTrackerWithId('UA-69121667-1');
      analytics.startTrackerWithId('UA-69121667-1');
      //analytics.setDebugMode();

      $rootScope.isOnline = false;

      $rootScope.accountInit = 0;

      $rootScope.api = new Api();

      $rootScope.wasInitialized = false;

      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
        cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        $cordovaStatusbar.overlaysWebView(true);
        $cordovaStatusbar.style(0);

        $cordovaStatusbar.styleHex('#733a88'); // Mobil Lutri lila
      }

      if (window.cordova) {
        if ($cordovaNetwork.isOnline()) {
          $rootScope.isOnline = true;

          // listen for Online event
          $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
            $rootScope.isOnline = true;
          });

          // listen for Offline event
          $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
            $rootScope.isOnline = false;
          });
        }
      }

      $rootScope.onState = "login";

      $rootScope.refreshBalance = function () {
        var balance = window.localStorage.getItem("balance");
        $rootScope.actualBalance = balance;
      };

      $rootScope.saveData = function (name, data) {
        window.localStorage.setItem(name, data);
      };

      $rootScope.getData = function (name) {
        return window.localStorage.getItem(name);
      };

      $rootScope.removeData = function (name) {
        window.localStorage.removeItem(name);
      };

      $rootScope.counter = TIMER;
      var mytimeout = null; // the current timeoutID
      // actual timer method, counts down every second, stops on zero
      $rootScope.onTimeout = function () {
        if ($rootScope.counter === 0) {
          $rootScope.$broadcast('timer-stopped', 0);
          $timeout.cancel(mytimeout);
          return;
        }
        $rootScope.counter--;
        //console.log($rootScope.counter);
        mytimeout = $timeout($rootScope.onTimeout, 1000);
      };
      $rootScope.startTimer = function () {
        console.log("Timer started");
        mytimeout = $timeout($rootScope.onTimeout, 1000);
      };
      // stops and resets the current timer
      $rootScope.stopTimer = function () {
        //console.log("Stopping counter");
        $rootScope.$broadcast('timer-stopped', $rootScope.counter);
        $rootScope.counter = TIMER;
        $timeout.cancel(mytimeout);
      };
      // triggered, when the timer stops, you can do something here, maybe show a visual indicator or vibrate the device
      $rootScope.$on('timer-stopped', function (event, remaining) {
        if (remaining === 0) {
          //console.log('your time ran out!');
          $state.go('tab.letters', {state: 1, list: "hide"});

          $rootScope.counter = TIMER;

        }
      });

      $rootScope.goTo = function (num) {
        switch (num) {
          case '3':
            $rootScope.counter = TIMER;
            break;
          case '4':
            $rootScope.counter = TIMER + 20;
            break;
          case '5':
            $rootScope.counter = TIMER + 40;
            break;
          case '6':
            $rootScope.counter = TIMER + 60;
            break;
        }
        console.log($rootScope.counter);
        $rootScope.startTimer();
        $state.go('tab.letters', {state: num, list: "hide"});
        //$state.transitionTo("tab.letters", { state: num, list: "hide" });
      };

      $rootScope.$on('$stateChangeStart',
        function (event, toState, toParams, fromState, fromParams) {

          //console.log("StateChangeStarted to: " + toState.name);

          if (toState.name == 'walkthrough' || toState.name == 'tab.prizes' || toState.name == 'tab.buy' || (toState.name == 'tab.info' && (toParams.state == 3 || toParams.state == 2))) {
            $cordovaStatusbar.style(1);
          } else {
            $cordovaStatusbar.style(0);
          }

          if (toState.name == "tab.letters" && toParams.state != 1) {
            if (!$rootScope.canPlay) {
              $cordovaToast.show('Ez egy próbajáték!', 'long', 'center')

            }
          }

          if (toState.name == "tab.letters") {
            if ($rootScope.refreshBalance) {
              $rootScope.refreshBalance();
            }
          }

          if (toState.name == "tab.letters" && toParams.list == "show") {
            console.log("Getting words for " + (toParams.state - 2 ));
            $rootScope.getUserWords(toParams.state - 2);
          }

          if (toState.name == "tab.prizes") {

            if (toParams.state == 1) {
              $rootScope.loadPrizes();
              //console.log("load prizes");
            } else {
              //console.log("load winners");
              $rootScope.loadWinners();
            }
          }

          if (toState.name == "tab.buy") {
            if (!$rootScope.wasInitialized) {
              console.log("INIT STORE");
              if ($rootScope.initStore) {
                $rootScope.initStore();
              }
            }

            if (toParams.state != 1) {
              $rootScope.historyPage = 1;
              $rootScope.transactions = [];
              $rootScope.getHistory(1);
            }

          }

          if (toState.name == "tab.account") {
            $rootScope.profilePic = window.localStorage.getItem("profilePic");
            $rootScope.profileName = window.localStorage.getItem("name");
            $rootScope.profileEmail = window.localStorage.getItem("email");
            $rootScope.actualBalance = window.localStorage.getItem("balance");

            if ($rootScope.accountInit == 0) {
              if ($rootScope.initAccount) {
                $rootScope.initAccount();
              }
            }

          }

          if (toState.name == "login") {
            $cordovaStatusbar.style(0);
          }

          $rootScope.onState = toState.name;

          //Analytics

          var options = {};

          function success(response) {
            //console.log(response);
          }

          function error(response) {
            //console.log(response);
          }

          $rootScope.isOnline = $cordovaNetwork.isOnline();

          if (toState.name == "tab.prizes") {
            if ($rootScope.prizeInit) {
              $rootScope.prizeInit();
            }
          }

          if (fromState.name != "register" || toState.name != "register" || toState.name != "login") {
            if ($rootScope.isOnline && window.localStorage.getItem("token") != null) {
              $rootScope.api.get("profile", {token: window.localStorage.getItem("token")}, function (response) {

                $rootScope.profilePic = response.data.data.image;

                if (response.data.data.balance == 0) {
                  $rootScope.canPlay = false;
                } else {
                  $rootScope.canPlay = true;
                }

              });
            }
          }

          analytics.trackView(toState.name, options, success, error);

        });
    });
  })

  .controller("StartCtrl", function ($scope, $ionicPlatform, $state, $rootScope, $ionicHistory, $cordovaStatusbar) {

    $ionicHistory.nextViewOptions({
      disableAnimate: true,
      disableBack: true
    });
    $ionicPlatform.ready(function () {
      if (window.localStorage.getItem("walkthrough") == null) {
        $state.go("walkthrough");
        $cordovaStatusbar.style(1);
      } else {
        $state.go("login");
      }
    });
  })

  .controller("WalkthroughCtrl", function ($scope, $state, $rootScope) {
    $scope.login = function () {
      window.localStorage.setItem("walkthrough", 1);
      $state.go("login");
    };
  })

  .controller("TabsCtrl", function ($scope, $ionicHistory, $rootScope) {

    $scope.state = $rootScope.onState;

    $rootScope.$on('$stateChangeStart',
      function (event, toState, toParams, fromState, fromParams) {
        $scope.state = toState.name;
      });
    /*
     $(".prize-tab").change(function () {
     console.log("Changed");
     });
     */
    $(window).on("touchstart", function (ev) {
      var e = ev;

      if (e.target.classList[0] == "prize-tab") {
        $('.tab-bg.left').addClass("activated");
      }

      if (e.target.classList[0] == "purchase-tab") {
        $('.tab-bg.right').addClass("activated");
      }

    });

    //Ha lehúzzuk az ujjunkat a tabról ne maradjon ott a sötét szín a szélén...
    $(window).on("touchend", function (ev) {
      if ($scope.state != "tab.prizes") {
        $('.tab-bg.left').removeClass("activated");
      }

      if ($scope.state != "tab.buy") {
        $('.tab-bg.right').removeClass("activated");
      }

    });

    $(window).on("touchmove", function (ev) {


      // TODO:
      // Megoldani, hogy egyszerre removeolja a classt....


    });


  })

  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $cordovaInAppBrowserProvider) {

    // Ionic uses AngularUI Router which uses the concept of states
    // Learn more here: https://github.com/angular-ui/ui-router
    // Set up the various states which the app can be in.
    // Each state's controller can be found in controllers.js
    $stateProvider

    // setup an abstract state for the tabs directive
      .state('tab', {
        url: '/tab',
        abstract: true,
        templateUrl: 'templates/tabs.html',
        controller: 'TabsCtrl'
      })

      // Each tab has its own nav history stack:

      .state('tab.dash', {
        url: '/dash',
        views: {
          'tab-dash': {
            templateUrl: 'templates/tab-dash.html',
            controller: 'DashCtrl'
          }
        }
      })

      .state('login', {
        url: '/login',
        templateUrl: 'templates/login.html',
        controller: 'LoginCtrl'
      })

      .state('register', {
        url: '/register/:type',
        templateUrl: 'templates/register.html',
        controller: 'RegisterCtrl'
      })

      .state('tab.letters', {
        url: '/letters/:state/:list',
        views: {
          'tab-letters': {
            templateUrl: 'templates/tab-letters.html',
            controller: 'LettersCtrl'
          }
        }
      })

      .state('tab.prizes', {
        url: '/prizes/:state/:cat',
        views: {
          'tab-prizes': {
            templateUrl: 'templates/tab-prizes.html',
            controller: 'PrizesCtrl'
          }
        }
      })

      .state('tab.buy', {
        url: '/buy/:state',
        views: {
          'tab-buy': {
            templateUrl: 'templates/tab-buy.html',
            controller: 'BuyCtrl'
          }
        }
      })

      .state('tab.chat-detail', {
        url: '/chats/:chatId',
        views: {
          'tab-chats': {
            templateUrl: 'templates/chat-detail.html',
            controller: 'ChatDetailCtrl'
          }
        }
      })

      .state('tab.account', {
        url: '/account/:state',
        views: {
          'tab-account': {
            templateUrl: 'templates/tab-account.html',
            controller: 'AccountCtrl'
          }
        }
      })

      .state('start', {
        url: '/start',
        templateUrl: 'templates/start.html',
        controller: 'StartCtrl',
        data: {
          authenticate: false
        }
      })

      .state('walkthrough', {
        url: '/walkthrough',
        templateUrl: 'templates/walkthrough.html',
        controller: 'WalkthroughCtrl',
        data: {
          authenticate: false
        }
      })

      .state('tab.info', {
        url: '/info/:state/:cat',
        views: {
          'tab-info': {
            templateUrl: 'templates/tab-info.html',
            controller: 'InfoCtrl'
          }
        }
      });

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('start');

    $ionicConfigProvider.tabs.position('bottom'); // other values: top
    $ionicConfigProvider.backButton.previousTitleText(false);
    $ionicConfigProvider.backButton.text("Vissza");
    $ionicConfigProvider.views.swipeBackEnabled(false);

    // In App Browser beállítások
    var options = {
      location: 'no', // Kieírja-e a címet
      clearcache: 'yes', // Cache ürítés
      toolbar: 'yes', // Vissza gombok stb.
    };

    if (ionic.Platform.isIOS()) {
      options.transitionstyle = 'fliphorizontal'; // Átfedés animáció
      options.toolbarposition = 'top'; // Toolbar pozíció
      options.closebuttoncaption = 'Vissza'; // Done felirat átírva


      //if(device.version >= 9){
      //    $ionicConfigProvider.views.transition('none');
      //}

    }

    $cordovaInAppBrowserProvider.setDefaultOptions(options);


  });
