angular.module('buy', ['Api'])

  .controller('BuyCtrl', function ($scope, $state, $ionicHistory, $stateParams, $rootScope, $ionicLoading, $cordovaStatusbar, $cordovaDialogs, $cordovaToast, $timeout, Api) {

    $scope.api = new Api();

    $scope.coinCount = 0;

    $scope.platform = ionic.Platform.platform();

    $scope.balance = $rootScope.actualBalance;

    $rootScope.historyPage = 1;

    $rootScope.transactions = [];

    $scope.canLoadMore = true;

    $scope.pressedPurchase = false;


    if ($stateParams.state != "") {
      $scope.state = $stateParams.state;
    } else {
      $scope.state = 1;
    }

    if ($scope.state == 1) {

      /*$rootScope.$on('$stateChangeStart',
       function (event, toState, toParams, fromState, fromParams) {

       console.log(toParams.state);

       //Ha offlineból átlépünk online-ba akkor töltse be a storet...
       if (toState.name == "tab.buy" && $rootScope.isOnline) {
       if (!$scope.wasInitialized && toParams.state == 1) {
       $scope.initStore();
       }
       }

       });*/

      $rootScope.$on('$stateChangeStart',
        function (event, toState, toParams, fromState, fromParams) {
          // do something
          if (toState.name == "tab.buy" && toParams.state == 1) {
            //console.log(JSON.stringify(toParams));
          }

        });

    }

    if ($scope.state == 1) {
      $scope.header = "Vásárlás";
      $scope.scrollable = false;
    } else {
      $scope.header = "Előzményeim";
      $scope.scrollable = true;
    }

    $scope.load = function (num) {
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        disableBack: false
      });

      $rootScope.prizeCategory = num;

      $state.go('tab.buy', {state: num});
    };

    $scope.init = function () {
      if ($scope.state == 1) {
        if ($rootScope.isOnline) {
          $rootScope.initStore();
        }
      } else {
        //$scope.getHistory($scope.historyPage);
      }
    };

    // BLACKMAGIC
    $scope.asyncLoop = function (o) {
      var i = -1,
        length = o.length;
      var loop = function () {
        i++;
        if (i == length) {
          o.callback();
          return;
        }
        o.functionToLoop(loop, i);
      };
      loop(); //init
    };

    $scope.getPackageId = function (store_id) {

    }

    $rootScope.initStore = function () {

      $ionicLoading.show();
      $scope.packages = [];
      $scope.products = [[], []];
      $scope.enable = false;
      $scope.couponCode = null;

      if (!window.store) {
        //alert('Store not available');
        return;
      }

      $scope.api.get("packages", {token: window.localStorage.getItem("token")}, function (response) {
        if (response.data.success == true) {
          $scope.packages = response.data.data;

          // Enable maximum logging level
          store.verbosity = store.INFO;
          // Inform the store of your products
          console.log('registerProducts');
          var i = 0;
          var id = 0;

          store.validator = function (product, callback) {
            console.log("VALIDATING PURHCASE!!!!");


            //console.log(JSON.stringify(product.transaction));

            $scope.api.post("purchaseValidate", {
              token: window.localStorage.getItem("token"),
              type: product.transaction.type,
              receipt: product.transaction.transactionReceipt || product.transaction.receipt,
              signature: product.transaction.signature
            }, function (ret) {

              console.log(ret);
              if (ret.data.success) {
                product.verified = true;
                callback(true, product);
              } else {
                product.verified = false;
                callback(false, product);
              }

            }, function (ret) {

              console.log(ret);
              product.verified = false;
              callback(false, product);
            });

            //console.log(JSON.stringify(product.transaction));
          };

          angular.forEach($scope.packages, function (value, key) {

            if (value.DailyDeal.cost != null) {
              value.hasDailyDeal = true;
              value.Package.newCost = parseInt(value.Package.cost) + parseInt(value.DailyDeal.cost);
            } else {
              value.Package.newCost = parseInt(value.Package.cost);
            }

            store.register({
              id: value.Package.store_id,
              alias: value.Package.name,
              type: store.CONSUMABLE
            });

            store.when(value.Package.store_id).valid(function (product) {
              // asynchronous
              $scope.setPrices(value.Package.store_id, product.price);
              //v.Package.price = product.price;
            });

            store.when(value.Package.store_id).cancelled(function (product) {
              console.log("PURCHASE CANCELLED");
              $scope.couponCode = null;
              $ionicLoading.hide();
              //product.finish();
            });

            store.when(value.Package.store_id).owned(function (product) {
              $ionicLoading.hide();
              product.finish();
            });

            store.when(value.Package.store_id).approved(function (order) {
              console.log("PURCHASE APPROVED");
              //console.log(JSON.stringify(order));

              order.verify();
            });

            store.when(value.Package.store_id).verified(function (order) {
              //console.log(JSON.stringify(order));
              //TODO... Start verify

              order.finish();
            });

            store.when(value.Package.store_id).unverified(function (order) {
              order.finish();
            });

            store.when(value.Package.store_id).finished(function (order) {
              //if ($scope.pressedPurchase) {
              console.log("PURCHASE FINISHED");
              if (order.verified == true) {
                console.log(JSON.stringify(order));
                var dailyDealId = "";
                //var coinNum = value.Package.cost;
                if (value.hasDailyDeal == true) {
                  dailyDealId = value.DailyDeal.id;
                  // coinNum = value.DailyDeal.cost;
                }

                $scope.api.post("addCredit", {
                  token: window.localStorage.getItem("token"),
                  type: order.transaction.type,
                  packageId: value.Package.id,
                  dailyDealId: dailyDealId,
                  purchaseId: order.transaction.id
                }, function (response) {
                  if (response.data.success == false) {
                    // $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
                    console.log(JSON.stringify(response.data));
                    $scope.couponCode = null;
                  } else if (response.data.message != null) {
                    $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');
                    window.localStorage.setItem("balance", response.data.data.balance);
                    $scope.balance = window.localStorage.getItem("balance");
                    $rootScope.actualBalance = $scope.balance;
                  }
                  $scope.pressedPurchase = false; // Lenullázzuk!!!
                });
                /*
                 {"id":"com.eclickmobile.mobillutri.300","alias":"300 Coin","type":"consumable","state":"finished","title":"300 Lutri Pengő","description":"300 Lutri Pengő","price":"€0,99","currency":null,"loaded":true,"canPurchase":false,"owned":false,"downloading":false,"downloaded":false,"transaction":{"type":"ios-appstore","id":"1000000177539109"},"valid":true,"transactions":["1000000177539109"]}
                 */
                $scope.canLoadMore = true;
                $ionicLoading.hide();
                // }
              }
            });

            // Jó sorba beosztás
            if (i < 2) {
              $scope.products[id][i] = value;
            } else if (i == 2) {
              i = 0;
              id = id + 1;
              $scope.products[id][i] = value;
            }
            i++;
          });

          store.error(function (e) {
            console.log("ERROR " + e.code + ": " + e.message);
            $cordovaDialogs.alert(e.message, 'Hiba', 'OK');
            $ionicLoading.hide();
          });

          store.ready(function () {
            $ionicLoading.hide();
            $scope.enable = true;

            $scope.$apply();
            console.log("Store Ready!");
          });

          // After we've done our setup, we tell the store to do
          // it's first refresh. Nothing will happen if we do not call store.refresh()
          store.refresh();

          $rootScope.wasInitialized = true;

        } else {
          return;
        }
      });
    };

    $scope.setPrices = function (id, price) {
      angular.forEach($scope.products, function (value, key) {
        angular.forEach(value, function (v, k) {
          if (v.Package.store_id == id) {
            v.Package.price = price;
          }
        });
      });
    }

    $scope.purchase = function (id) {
      $ionicLoading.show();

      var product = id;

      $scope.startOrder(id);

    };

    $scope.startOrder = function (id) {

      $scope.pressedPurchase = true;

      var p = store.order(id).then(function (data) {
        console.log(data);
      }).error(function (error) {
        console.log(error);
      });
    }

    $scope.refresh = function () {
      store.refresh();
    };

    $rootScope.getHistory = function (page) {
      $scope.api.get("transactions", {
        token: window.localStorage.getItem("token"),
        page: page
      }, function (response) {
        if (response.data.success == true) {
          if (response.data.data.length != 0) {

            angular.forEach(response.data.data, function (transaction, key) {
              //console.log(" ");
              //console.log(JSON.stringify(transaction));
              $rootScope.transactions.push((transaction));
            });

            $scope.canLoadMore = true;
            $rootScope.historyPage++;
          } else {
            $scope.canLoadMore = false;
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
        } else {
          console.log("NOPE");
        }
      });
    };

    $scope.loadMore = function () {
      $timeout(function () {
        if ($scope.canLoadMore) {
          $scope.canLoadMore = false;
          $rootScope.getHistory($rootScope.historyPage);
        }
      }, 1000)
    };

  });
