angular.module('info', ['Api'])

  .directive('compile', ['$compile', function ($compile) {
    return function (scope, element, attrs) {
      scope.$watch(
        function (scope) {
          return scope.$eval(attrs.compile);
        },
        function (value) {
          element.html(value);
          $compile(element.contents())(scope);
        }
      )
    };
  }])

  .controller('InfoCtrl', function ($scope, $state, $stateParams, $ionicHistory, $rootScope, $cordovaDialogs, $cordovaInAppBrowser, Api) {

    $scope.api = new Api();

    $scope.votablePrizes = [];

    $scope.voteData = [];

    $scope.currentVote = {};

    if ($stateParams.state != "") {
      $scope.state = $stateParams.state;
    } else {
      $scope.state = 1;
    }

    if ($scope.state == 2) {
      $scope.headerStyle = "colored";
    } else {
      $scope.headerStyle = "white";
    }

    if ($stateParams.cat != "") {
      $scope.cat = $stateParams.cat;
    } else {
      $scope.cat = 3;
    }

    $scope.platform = ionic.Platform.platform();

    if ($scope.state == 1) {
      $scope.header = "<span class='mobil'>Mobi</span><span class='lutri'>Lutri</span>";
    } else if ($scope.state == 2) {
      $scope.header = "Info";
    } else if ($scope.state == 3) {
      $scope.header = "Szavazás";
    } else if ($scope.state == 4) {
      $scope.header = "GYIK";
    }

    $scope.load = function (num) {
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        disableBack: false
      });

      $rootScope.prizeCategory = num;

      $state.go('tab.info', {state: $scope.state, cat: num});
    };

    $scope.initVote = function () {
      $scope.api.get("votablePrizes", {token: window.localStorage.getItem("token")}, function (response) {
        var prizeObj = response.data.data;
        $scope.votablePrizes = response.data.data;
      });
    };

    $scope.change = function (cat, item) {
      $scope.currentVote = {
        cat: cat,
        id: item.VotablePrize.id
      }
    };

    $scope.sendVote = function (id) {

      $scope.api.post("vote", {
        token: window.localStorage.getItem("token"),
        votablePrizeId: id
      }, function (response) {
        if (response.data.success == false) {
          $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
        } else if (response.data.message != null) {
          $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');
        }
      });

    };

    $scope.back = function () {
      $state.go('tab.info', {state: 1});
    };

    $scope.goTo = function (num) {
      $state.go('tab.info', {state: num, cat: $scope.cat});
    };

    $scope.open = function () {
      $cordovaInAppBrowser.open("http://www.mobilutri.hu/", '_blank');
    };

    if (ionic.Platform.isAndroid()) {
      $scope.GYIK = [{
        id: 1,
        question: "Honnan és hogyan szerezhetem meg a Mobilutri alkalmazást? ",
        answer: "App Store, Google Play vagy közvetlen a <span class='link' ng-click='open()'>www.mobilutri.hu</span> weboldalról is elérhető az alkalmazás.",
        show: false
      }, {
        id: 2,
        question: "Milyen eszközökön támogatott az alkalmazás?",
        answer: "iOS és Android eszközök<br>A Mobilutri alkalmazás iOS 8.0 és Android 4.4 vagy magasabb verzión működnek",
        show: false
      }, {
        id: 3,
        question: "Ingyenes a Mobilutri alkalmazás?",
        answer: "Igen a Mobilutri alkalmazás ingyenesen tölthető le és használható. Mindemellett  az alkalmazás használatához internet elérés szükséges, ami adatforgalmat generál.",
        show: false
      }, {
        id: 4,
        question: "Szükség van adatforgalomra (internetkapcsolatra) a Mobilutri alkalmazások használatához?",
        answer: "Igen.",
        show: false
      }, {
        id: 5,
        question: "Nem tudok kapcsolódni az internethez, mit tegyek?",
        answer: "Kérjük, kövesd az alábbi lépéseket a problémamegoldás érdekében:<br><br>Repülőgép mód Ki: Győződj meg arról, hogy a „Repülőgép mód” ki van kapcsolva a „Beállítások” > „Repülőgép mód” menüpontban!<br> Internet kapcsolat: Ellenőrizd, hogy működik-e az internetkapcsolatod! <br>Mobile adatforgalmi hálózat (UMTS/EV-DO)<br>Mobile adatforgalmi hálózat (EDGE csak GSM készülékek esetén)<br>Mobile adatforgalmi hálózat (GPRS/1xRTT)<br>Wi-Fi<br><br>Ha az eszközön van aktív hálózati kapcsolat, akkor látszik a Wi-Fi ikon vagy valamelyik Mobile adatforgalmi hálózati ikon. <br>Ha Wi-Fi-t használsz, a Mobile adatforgalmi ikonok csak akkor látszanak, ha a Wi-Fi ki van kapcsolva.<br>",
        show: false
      }];
    } else if (ionic.Platform.isIOS()) {

      $scope.GYIK = [{
        id: 1,
        question: "Honnan és hogyan szerezhetem meg a Mobilutri alkalmazást? ",
        answer: "App Store vagy közvetlen a <span class='link' ng-click='open()'>www.mobilutri.hu</span> weboldalról is elérhető az alkalmazás.",
        show: false
      }, {
        id: 2,
        question: "Milyen eszközökön támogatott az alkalmazás?",
        answer: "iOS eszközök<br>A Mobilutri alkalmazás iOS 8.0 vagy magasabb verzión működnek",
        show: false
      }, {
        id: 3,
        question: "Ingyenes a Mobilutri alkalmazás?",
        answer: "Igen a Mobilutri alkalmazás ingyenesen tölthető le és használható. Mindemellett  az alkalmazás használatához internet elérés szükséges, ami adatforgalmat generál.",
        show: false
      }, {
        id: 4,
        question: "Szükség van adatforgalomra (internetkapcsolatra) a Mobilutri alkalmazások használatához?",
        answer: "Igen.",
        show: false
      }, {
        id: 5,
        question: "Nem tudok kapcsolódni az internethez, mit tegyek?",
        answer: "Kérjük, kövesd az alábbi lépéseket a problémamegoldás érdekében:<br><br>Repülőgép mód Ki: Győződj meg arról, hogy a „Repülőgép mód” ki van kapcsolva a „Beállítások” > „Repülőgép mód” menüpontban!<br> Internet kapcsolat: Ellenőrizd, hogy működik-e az internetkapcsolatod! <br>Mobile adatforgalmi hálózat (UMTS/EV-DO)<br>Mobile adatforgalmi hálózat (EDGE csak GSM készülékek esetén)<br>Mobile adatforgalmi hálózat (GPRS/1xRTT)<br>Wi-Fi<br><br>Ha az eszközön van aktív hálózati kapcsolat, akkor látszik a Wi-Fi ikon vagy valamelyik Mobile adatforgalmi hálózati ikon. <br>Ha Wi-Fi-t használsz, a Mobile adatforgalmi ikonok csak akkor látszanak, ha a Wi-Fi ki van kapcsolva.<br>",
        show: false
      }];
    }
    $scope.toggleAnswer = function (id) {
      angular.forEach($scope.GYIK, function (value, key) {
        if (value.id == id) {
          value.show = !value.show;
        }
      });
    };


  });
