angular.module('letters', ['Api', 'SQL'])

  .controller('LettersCtrl', function ($scope,
                                       $rootScope,
                                       $stateParams,
                                       $state,
                                       $timeout,
                                       $ionicPosition,
                                       $ionicPlatform,
                                       $ionicPopup,
                                       $cordovaStatusbar,
                                       $cordovaDialogs,
                                       $cordovaSQLite,
                                       $cordovaToast,
                                       $ionicLoading,
                                       $ionicHistory,
                                       Api,
                                       Category,
                                       Week,
                                       Word) {

    $scope.api = new Api();

    if ($stateParams.state != "") {
      $scope.state = $stateParams.state;
    } else {
      $scope.state = 1;
    }

    if ($stateParams.list != "") {
      $scope.list = $stateParams.list;
    } else {
      $scope.list = "hide";
    }
    $rootScope.actualBalance = window.localStorage.getItem("balance");
    $scope.balance = $rootScope.actualBalance;

    $scope.platform = ionic.Platform.platform();

    $scope.categories = [[], []];
    $scope.letters = [];
    $scope.userWords = [];

    $rootScope.positionLetters = function () {
      // Már nem kell ez a baszakodás :)
    };

    $rootScope.hideLetters = function () {

    };

    $scope.sortCategories = function (categories) {
      var i = 0;
      var id = 0;
      angular.forEach(categories, function (value, key) {
        // Jó sorba beosztás
        if (i < 2) {
          $scope.categories[id][i] = value;
        } else if (i == 2) {
          i = 0;
          id = id + 1;
          $scope.categories[id][i] = value;
        }
        i++;
      });
    };

    $scope.sortLetters = function (letters) {
      var letter_id = 0;
      angular.forEach(letters.massalhangzok, function (value, key) {
        var letterObject = {
          letter_id: letter_id,
          character: value,
          isIn: false,
          mg: false
        };
        $scope.letters.push(letterObject);
        letter_id++;
      });

      angular.forEach(letters.maganhangzok, function (value, key) {
        var letterObject = {
          letter_id: letter_id,
          character: value,
          isIn: false,
          mg: true
        };
        $scope.letters.push(letterObject);
        letter_id++;
      });
    }

    $scope.getWeekData = function () {
      if ($rootScope.isOnline) {
        $scope.api.get("weekData", {token: window.localStorage.getItem("token")}, function (response) {
          if (response.data.success == true) {
            // Kategóriák beosztása
            $scope.sortCategories(response.data.data.categories);

            //Betűk letárolása
            $scope.sortLetters(response.data.data.letters);

          } else {
            $cordovaDialogs.alert(response.data.message, 'Hiba', 'OK');
          }
        });
      } else {
        // Lokális SQLite fileból...
        Category.all().then(function (cat) {
          var categories = [];
          angular.forEach(cat, function (value, key) {
            // Létrehozzuk az ugyan olyan struktúrát mint amit az API ad vissza
            var tempObj = {
              Category: {
                id: value.categoryId,
                name: value.name,
                cost: value.cost,
                letter_num: value.letter_num
              }
            }
            categories.push(tempObj)
          });

          $scope.sortCategories(categories);
        });

        Week.letters().then(function (letters) {
          console.log("OFFLINE");
          var letter_count = [];
          angular.forEach(letters, function (value, key) {
            letter_count.push(JSON.parse(value.letter_count));
          });
          $scope.sortLetters(letter_count[0]);

        });

      }
    };

    $scope.init = function () {

      $scope.spaces = [];

      if ($scope.state != 1) {
        for (var i = 1; i <= $scope.state; i++) {
          $scope.spaces.push({
            id: i,
            hasLetter: false,
            letter: null
          });
        }
      }

      $scope.getWeekData();

      if ($scope.list == 'show') {
        $rootScope.getUserWords($scope.state - 2);
      }

    };

    $rootScope.getUserWords = function (categoryId) {
      $scope.api.get("userWords", {
        token: window.localStorage.getItem("token"),
        categoryId: categoryId
      }, function (response) {

        if (response.data.success == true) {
          $scope.userWords = response.data.data;

        } else {
          console.log(JSON.stringify(response.data.data));
        }
      });
    };

    $scope.getPosToPut = function () {
      for (var i = 0; i < $scope.spaces.length; i++) {
        if ($scope.spaces[i].hasLetter == false) {
          return i + 1;
        }
      }
    };

    $scope.moveBtn = function (letter) {

      $scope.charAt = $scope.getPosToPut();

      var b = $('#letter_lvl_' + $scope.state + "_" + letter.character + "_" + letter.letter_id);
      var t = $('#space_lvl_' + $scope.state + "_" + $scope.charAt);
      var button = b.get(0);
      var toPos = t.get(0);

      if (!letter.isIn) {
        if (toPos == null) {
          //alert("Nincs több hely!");
          return;
        }
        var buttonTop = b.offset().top;
        var buttonLeft = b.offset().left;
        letter.orgY = buttonTop;
        letter.orgX = buttonLeft;
        var toTop = t.offset().top;
        var toLeft = t.offset().left;
        var y = toTop - buttonTop;
        var x = toLeft - buttonLeft;

        var bgColor = "transparent";
        var textColor = "#733a88";
        var minWidth = 0;
        var minHeight = 0;


        letter.isIn = true;
        letter.pos = $scope.charAt;
        $scope.spaces[$scope.charAt - 1].hasLetter = true;
        $scope.spaces[letter.pos - 1].letter = letter.character;
        $scope.charAt = $scope.getPosToPut;
      } else {
        var buttonTop = b.offset().top;
        var buttonLeft = b.offset().left;
        var toTop = letter.orgY;
        var toLeft = letter.orgX;
        var y = 0;
        var x = 0;

        if (!letter.mg) {
          var bgColor = "#733a88";
        } else {
          var bgColor = "#fbc14c";
        }
        var textColor = "#fff";

        var minWidth = "52px";
        var minHeight = "47px";

        $scope.spaces[letter.pos - 1].hasLetter = false;
        $scope.spaces[letter.pos - 1].letter = null;
        letter.isIn = false;
        letter.pos = null;
        $scope.charAt = $scope.getPosToPut();
      }

      move(button)
        .ease('in-out')
        .y(y)
        .x(x)
        .set('background-color', bgColor)
        .set('color', textColor)
        .set('border-color', bgColor)
        .duration('0.2s')
        .end();

      var inCount = 0;

      angular.forEach($scope.letters, function (value, key) {
        if (value.isIn) {
          inCount++;
        }
      });

      if (inCount == $scope.spaces.length) {
        $timeout(function () {
          $scope.checkCorrect();
        }, 500);
      }
    };

    $scope.resetLetters = function () {
      angular.forEach($scope.letters, function (value, key) {
        if (value.isIn) {
          $scope.moveBtn(value);
        }
      });
    };

    $scope.checkCorrect = function () {
      console.log("Betűk felküldése");
      var catId = $scope.state - 2;
      var word = "";

      angular.forEach($scope.spaces, function (v, k) {
        word += v.letter;
      });

      Word.match(word).then(function (response) {
        if (response.length > 0) {
          if ($rootScope.isOnline) {
            if ($rootScope.canPlay) {
              $ionicLoading.show();
              $scope.api.post("addWord", {
                token: window.localStorage.getItem("token"),
                categoryId: catId,
                word: word
              }, function (response) {
                if (response.data.success == false) {
                  $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');

                } else if (response.data.message != null) {
                  $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');

                  window.localStorage.setItem("balance", response.data.data.balance);
                  $scope.balance = window.localStorage.getItem("balance");
                  $rootScope.actualBalance = $scope.balance;

                }

                $scope.resetLetters();

                $ionicLoading.hide();
              });
            } else {
              $cordovaDialogs.confirm('Ez egy helyes szó, azonban sajnos nincs elegendő Lutri Pengőd! A vásárlás menüpont alatt tudsz szerezni. ', 'Próba játék', ['Vissza', 'Vásárlás'])
                .then(function (buttonIndex) {
                  // no button = 0, 'OK' = 1, 'Cancel' = 2
                  var btnIndex = buttonIndex;
                  $scope.resetLetters();
                  if (btnIndex == 2) {
                    $state.transitionTo('tab.buy', {state: 1});
                  } else {
                    $rootScope.stopTimer();
                    $rootScope.counter = "";
                    $ionicHistory.goBack();
                  }

                });
            }
          } else {
            $cordovaDialogs.alert("Aktív internet kapcsolatra van szükség a szó beküldéséhez.", 'Hiba', 'Ok');
            //$scope.showAlert("Hiba", "Aktív internet kapcsolatra van szükség a szó beküldéséhez.");
          }
        } else {
          $cordovaToast.showShortCenter('Az adott szó nincs benne az adatbázisban.').then(function (success) {
            // success
          }, function (error) {
            // error
          });
          console.log("Nincs találat!");
        }
      });
    };

    $scope.showList = function (num) {
      //$state.go('tab.letters', );
      $state.transitionTo("tab.letters", {state: num, list: "show"});
    };

    $scope.back = function () {
      if ($scope.list != "hide") {
        $ionicHistory.nextViewOptions({
          disableAnimate: true
        });
      }
      $ionicHistory.goBack();
      $state.transitionTo('tab.letters', {state: 1});
      $rootScope.stopTimer();
      $rootScope.counter = "";
    };

    $scope.showAlert = function (title, text) {
      var alertPopup = $ionicPopup.alert({
        title: title,
        template: text
      });
      alertPopup.then(function (res) {
        //console.log('Thank you for not eating my delicious ice cream cone');
      });
    };

  });
