angular.module('login', ['Api'])

	.controller('LoginCtrl', function ($scope, $ionicPlatform, $rootScope, $state, $cordovaFacebook, $ionicHistory, $cordovaStatusbar, $cordovaDialogs, $cordovaPush, Api) {

		$scope.data = [];
		$scope.api = new Api();
		$rootScope.loginVisible = false;

		$rootScope.profilePic = "img/photo.jpg";
		$rootScope.profileName = "";
		$rootScope.profileId = "";
		$rootScope.actualBalance = 0;

		$rootScope.accountInit = 0;

		// Initnél megvizsgáljuk, hogy be van-e jelentkezve
		$scope.init = function () {

			console.log("Login init");

			// Teszt kedvéért...
			//window.localStorage.removeItem("token");
			$ionicPlatform.ready(function () {


				// Ha van accessToken
				if (window.localStorage.getItem("token") != null) {
					if ($rootScope.isOnline) {
						//Megnézzük, hogy érvényes-e
						$scope.api.get("loggedIn", { token: window.localStorage.getItem("token") }, function (response) {

							if (response.data.success == true) {
								$scope.loginSuccess();
							} else {
								$rootScope.loginVisible = true;
							}

							if (response.data == null) {
								$rootScope.loginVisible = true;
							}

						});
					} else {
						console.log("OFFLINE DE VAN TOKEN")
						$scope.loginSuccess();
					}
				} else {
					// Hagyjuk a login oldalon...
					$rootScope.loginVisible = true;
				}

			});
		};

		$scope.login = function () {
			if ($rootScope.isOnline) {
				if ($scope.data.mail == null) {
					$(".email input").addClass("error");
				}
				if ($scope.data.password == null) {
					$(".password input").addClass("error");
				}

				if ($scope.data.mail == null || $scope.data.password == null) {
					return;
				} else {
					$scope.api.post("login", { email: $scope.data.mail, password: $scope.data.password }, function (response) {
						if (response.data.success == false) {
							$cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
						} else {
							// Sikeres login
							//$cordovaDialogs.alert(JSON.stringify(response.data.data), 'Siker', 'Ok');
							$rootScope.profileName = response.data.data.name;
							$rootScope.profileEmail = response.data.data.email;

							$rootScope.profilePic = response.data.data.image;

              console.log(response);

							if ($rootScope.profilePic == null) {
								$rootScope.profilePic = "img/photo.jpg";
							}
							//Analytics USER ID:
							analytics.setUserId(response.data.data.id);

							window.localStorage.setItem("token", response.data.data.token);

							window.localStorage.setItem("name", response.data.data.name);
							window.localStorage.setItem("email", response.data.data.email);
							window.localStorage.setItem("profilePic", $rootScope.profilePic);
							window.localStorage.setItem("balance", response.data.data.balance);


							if (ionic.Platform.isAndroid()) {
								$scope.registerAndroidPush(response.data.data.token);
							} else if (ionic.Platform.isIOS()) {
								$scope.registerIOSPush(response.data.data.token);
							}


							$rootScope.balance = response.data.data.balance;

							$state.go('tab.account', { state: 1 });
						}
					});
				}
			} else {
				$cordovaDialogs.alert("A belépéshez internetkapcsolat szükséges!", 'Hiba', 'Ok');
			}
		};

		// Sikeres login után átdob a profilom oldalra
		$scope.loginSuccess = function () {
			$ionicHistory.nextViewOptions({
				disableAnimate: false,
				disableBack: true
			});

			$rootScope.profilePic = window.localStorage.getItem("profilePic");
			$rootScope.profileName = window.localStorage.getItem("name");
			$rootScope.profileId = window.localStorage.getItem("id");
			$rootScope.profileEmail = window.localStorage.getItem("email");
			$rootScope.actualBalance = window.localStorage.getItem("balance");

			$state.go('tab.account', { state: 1 });
		};

		// Átdob a register oldalra
		$scope.register = function () {
			$ionicHistory.nextViewOptions({
				disableAnimate: false,
				disableBack: false
			});
			$state.go('register', { type: "normal" });
		};

		$scope.forgotPassword = function () {
			if ($rootScope.isOnline) {
				$cordovaDialogs.prompt("Kérjük adja meg az email címét amivel regisztrált!", "Elfelejtett jelszó", ["Vissza", "OK"], "").then(function (result) {
					var input = result.input1;
					// no button = 0, 'OK' = 1, 'Cancel' = 2
					var btnIndex = result.buttonIndex;

					if (btnIndex == 2) {
						if (input == "") {
							$cordovaDialogs.alert('Adja meg az email címét!', 'Hiba', 'OK');
						} else {
							$scope.api.post("forgottenPassword", { email: input }, function (response) {
								if (response.data.success == false) {
									$cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
								} else if (response.data.message != null) {
									$cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');
								}
							});
						}
					}
				});
			} else {
				$cordovaDialogs.alert("Az elfelejtett jelszó kiküldéséhez internetkapcsolat szükséges!", 'Hiba', 'Ok');
			}
		};


		$scope.registerIOSPush = function (token) {
			var iosConfig = {
				"badge": true,
				"sound": true,
				"alert": true,
			};
			document.addEventListener("deviceready", function () {
				$cordovaPush.register(iosConfig).then(function (deviceToken) {
					// Success -- send deviceToken to server, and store for future use
					//console.log("deviceToken: " + deviceToken);

					//$http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + deviceToken + "&type=ios")

					$scope.api.post("pushId", { token: token, pushIosToken: deviceToken, pushAndroidToken: "" }, function (response) {
						console.log(JSON.stringify(response));
					});

				}, function (err) {
					alert("Registration error: " + err);
				});
				$rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
					if (notification.alert) {
						navigator.notification.alert(notification.alert);
					}

					if (notification.sound) {
						var snd = new Media(event.sound);
						snd.play();
					}

					if (notification.badge) {
						$cordovaPush.setBadgeNumber(notification.badge).then(function (result) {
							// Success!
						}, function (err) {
							// An error occurred. Show a message to the user
						});
					}
				});
				/*// WARNING! dangerous to unregister (results in loss of tokenID)
				 $cordovaPush.unregister(iosConfig).then(function (result) {
				 // Success!
				 }, function (err) {
				 // Error
				 });*/
			}, false);
		};

		$scope.registerAndroidPush = function (token) {
			var androidConfig = {
				"senderID": "15325689404",
			};

			document.addEventListener("deviceready", function () {
				$cordovaPush.register(androidConfig).then(function (result) {
					// Success
				}, function (err) {
					// Error
				});

				$rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
					switch (notification.event) {
						case 'registered':
							if (notification.regid.length > 0) {
								// Kiírja az ID-t midnen egyes idnításkor
								//alert('registration ID = ' + notification.regid);
								//$http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + notification.regid + "&type=android");
								$scope.api.post("pushId", { token: token, pushIosToken: "", pushAndroidToken: notification.regid }, function (response) {
									console.log(JSON.stringify(response));
								});
							}
							break;

						case 'message':
							// this is the actual push notification. its format depends on the data model from the push server
							// Ha megnyitod az appot notification után akkor dobna egy alertet...
							// alert('message = ' + notification.message + ' msgCount = ' + notification.msgcnt);
							break;

						case 'error':
							alert('GCM error = ' + notification.msg);
							break;

						default:
							alert('An unknown GCM event has occurred');
							break;
					}
				});


				/*// WARNING: dangerous to unregister (results in loss of tokenID)
				 $cordovaPush.unregister(options).then(function (result) {
				 // Success!
				 }, function (err) {
				 // Error
				 })*/
			}, false);
		}

		$scope.loginFb = function () {
			$ionicHistory.nextViewOptions({
				disableAnimate: false,
				disableBack: true
			});

			$cordovaFacebook.logout(function(){

			}, function(){

			}) ;

			$cordovaFacebook.login(["public_profile", "email", "user_friends", "user_birthday"])
				.then(function (success) {
					/*
					 * Get user data here.
					 * For more, explore the graph api explorer here: https://developers.facebook.com/tools/explorer/
					 * "me" refers to the user who logged in. Dont confuse it as some hardcoded string variable.
					 *
					 */
					//To know more available fields go to https://developers.facebook.com/tools/explorer/
					$cordovaFacebook.api("me?fields=id,name,email,birthday,picture.width(200).height(200)", [])
						.then(function (result) {
							/*
 * As an example, we are fetching the user id, user name, and the users profile picture
 * and assiging it to an object and then we are logging the response.
 */
							var userData = {
								id: result.id,
								name: result.name,
								email: result.email,
								birthday: result.birthday,
								pic: result.picture.data.url
							}
							//Do what you wish to do with user data. Here we are just displaying it in the view
							$scope.fbData = JSON.stringify(userData, null, 4);

							$rootScope.profilePic = userData.pic;
							$rootScope.profileName = userData.name;
							$rootScope.profileId = userData.id;
							$rootScope.profileEmail = userData.email;

							if (userData.birthday != null) {
								$rootScope.profileBirthday = userData.birthday;
							} else {
								$rootScope.profileBirthday = new Date();
							}

							//console.log($scope.fbData);

							// TODO:
							// API kérést küldeni szerver felé, lekérdezni, hogy be van-e lépve, vagy regisztrálásra szorul-e

							$scope.api.post("login", { facebook_id: userData.id, image: userData.pic }, function (response) {
								if (response.data.success == false) {
									//$cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
									$state.go('register', { type: "facebook" });
								} else {
									// Sikeres login
									console.log(JSON.stringify(response.data.data));

									//Analytics USER ID:
									console.log("User ID:" + response.data.data.id);
									analytics.setUserId(response.data.data.id);

									// Lementjük a tokent
									window.localStorage.setItem("token", response.data.data.token);
									window.localStorage.setItem("name", $rootScope.profileName);
									window.localStorage.setItem("email", $rootScope.profileEmail);
									window.localStorage.setItem("profilePic", $rootScope.profilePic);
									window.localStorage.setItem("balance", response.data.data.balance);

									if (ionic.Platform.isAndroid()) {
										$scope.registerAndroidPush(response.data.data.token);
									} else if (ionic.Platform.isIOS()) {
										$scope.registerIOSPush(response.data.data.token);
									}

									$rootScope.actualBalance = response.data.data.balance;
									$rootScope.profilePic = window.localStorage.getItem("profilePic");
									$rootScope.profileName = window.localStorage.getItem("name");
									$rootScope.profileId = window.localStorage.getItem("id");
									$rootScope.profileEmail = window.localStorage.getItem("email");

									$state.go('tab.account', { state: 1 });
								}
							});

						}, function (error) {
							// Error message

							console.log(JSON.stringify(error));

						})

				}, function (error) {
					// Facebook returns error message due to which login was cancelled.
					// Depending on your platform show the message inside the appropriate UI widget
					// For example, show the error message inside a toast notification on Android


					console.log(JSON.stringify(error));

				});
		};
	})
