angular.module('prizes', ['Api'])

  .controller('PrizesCtrl', function ($scope, $state, $rootScope, $stateParams, $ionicHistory, $ionicPosition, $cordovaStatusbar, Api) {

    $scope.state = $stateParams.state;
    $scope.cat = $stateParams.cat;

    $scope.api = new Api();

    $scope.platform = ionic.Platform.platform();

    $scope.letterNumber = 3;

    $scope.stateNumber = 0;

    $scope.prizes = [];
    $scope.winners = [];

    if ($scope.state == 1) {
      $scope.header = "Nyeremények";
    } else {
      $scope.header = "Nyertesek";
    }

    $rootScope.prizeInit = function () {
      $rootScope.prizeCategory = 3;

      if ($scope.state == 1) {
        $rootScope.loadPrizes();
      } else {
        $rootScope.loadWinners();
      }

    };

    $scope.load = function (num) {
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        disableBack: false
      });

      $rootScope.prizeCategory = num;

      $state.go('tab.prizes', {state: $scope.state, cat: num});
    };

    $scope.winners = function () {
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: false
      });
      $state.go('tab.prizes', {state: 2, cat: $scope.cat});
    };

    $scope.back = function () {
      $ionicHistory.nextViewOptions({
        disableAnimate: false,
        disableBack: false
      });
      $state.go('tab.prizes', {state: 1, cat: $scope.cat});
    };

    $rootScope.loadPrizes = function () {
      var cat = $scope.cat - 2;
      if ($rootScope.isOnline) {
        $scope.api.get("prizes", {
          token: window.localStorage.getItem("token"),
          categoryId: cat
        }, function (response) {
          $scope.prizes = response.data.data[$scope.cat];
        });
      }
    };

    $rootScope.loadWinners = function () {
      var cat = $scope.cat - 2;
      if ($rootScope.isOnline) {
        $scope.api.get("winners", {
          token: window.localStorage.getItem("token"),
          categoryId: cat
        }, function (response) {
          $scope.winners = response.data.data[$scope.cat];
        });
      }
    };


  });
