(function () {

    var push = angular.module('push', []);

    push.run(function ($http, $cordovaPush, $rootScope) {

	console.log("Push module loaded");
	if (ionic.Platform.isIOS()) {
	    var iosConfig = {
		"badge": true,
		"sound": true,
		"alert": true,
	    };
	    document.addEventListener("deviceready", function () {
		$cordovaPush.register(iosConfig).then(function (deviceToken) {
		    // Success -- send deviceToken to server, and store for future use
		    console.log("deviceToken: " + deviceToken)

		    $http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + deviceToken + "&type=ios")
		}, function (err) {
		    alert("Registration error: " + err);
		});
		$rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
		    if (notification.alert) {
			navigator.notification.alert(notification.alert);
		    }

		    if (notification.sound) {
			var snd = new Media(event.sound);
			snd.play();
		    }

		    if (notification.badge) {
			$cordovaPush.setBadgeNumber(notification.badge).then(function (result) {
			    // Success!
			}, function (err) {
			    // An error occurred. Show a message to the user
			});
		    }
		});
		/*// WARNING! dangerous to unregister (results in loss of tokenID)
		 $cordovaPush.unregister(iosConfig).then(function (result) {
		 // Success!
		 }, function (err) {
		 // Error
		 });*/
	    }, false);
	} else if (ionic.Platform.isAndroid()) {
	    var androidConfig = {
		"senderID": "794842933299",
	    };

	    document.addEventListener("deviceready", function () {
		$cordovaPush.register(androidConfig).then(function (result) {
		    // Success
		}, function (err) {
		    // Error
		})


		$rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
		    switch (notification.event) {
			case 'registered':
			    if (notification.regid.length > 0) {
				// Kiírja az ID-t midnen egyes idnításkor
				//alert('registration ID = ' + notification.regid);
				$http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + notification.regid + "&type=android");
			    }
			    break;

			case 'message':
			    // this is the actual push notification. its format depends on the data model from the push server
			    // Ha megnyitod az appot notification után akkor dobna egy alertet...
			    // alert('message = ' + notification.message + ' msgCount = ' + notification.msgcnt);
			    break;

			case 'error':
			    alert('GCM error = ' + notification.msg);
			    break;

			default:
			    alert('An unknown GCM event has occurred');
			    break;
		    }
		});


		/*// WARNING: dangerous to unregister (results in loss of tokenID)
		 $cordovaPush.unregister(options).then(function (result) {
		 // Success!
		 }, function (err) {
		 // Error
		 })*/
	    }, false);
	}
    });


}()
	);