angular.module('register', ['Api'])

  .controller('RegisterCtrl', function ($state, $scope, $rootScope, $stateParams, $ionicLoading, $cordovaPush, $cordovaDatePicker, $cordovaDialogs, $cordovaInAppBrowser, Api) {

    $scope.type = $stateParams.type;

    $scope.api = new Api();

    $scope.placeholder = {
      name: "Teljes név",
      mail: "Email cím",
      date: new Date(),
      password: "Jelszó",
      passwordAgain: "Jelszó újra",
    };

  /*  $('input[type="date"], input[type="datetime"], input[type="datetime-local"], input[type="month"], input[type="time"], input[type="week"]').each(function () {
      var el = this, type = $(el).attr('type');
      if ($(el).val() == '') $(el).attr('type', 'text');
      $(el).focus(function () {
        $(el).attr('type', type);
        el.click();
      });
      $(el).blur(function () {
        if ($(el).val() == '') $(el).attr('type', 'text');
      });
    });*/

    $scope.data = [];

    if ($scope.type == "facebook") {
      $scope.data.name = $rootScope.profileName;
      $scope.data.mail = $rootScope.profileEmail;
      $scope.data.id = $rootScope.profileId;
      $scope.data.date = new Date($rootScope.profileBirthday);
    } else {
      $scope.data.id = null;
      $scope.date = new Date();
      $scope.data.date = new Date();
    }

    var options = {
      date: $scope.date,
      mode: 'date', // or 'time'
      //minDate: new Date() - 10000,
      locale: "hu_HU",
      allowOldDates: true,
      allowFutureDates: false,
      x: $('body').width() / 2,
      y: $('.date').offset().top,
      popoverArrowDirection: "down",
      doneButtonLabel: 'KÉSZ',
      doneButtonColor: '#79428d',
      cancelButtonLabel: 'VISSZA',
      cancelButtonColor: '#79428d'
    };

    $scope.currentDate = new Date();
    $scope.minDate = new Date(1900, 1, 1);
    $scope.maxDate = new Date();

    $scope.datePickerCallback = function (val) {
      if (!val) {
        console.log('Date not selected');
      } else {
        console.log('Selected date is : ', val);
        $scope.date = val;
      }
    };

    $scope.showDatePicker = function () {
      /*$cordovaDatePicker.show(options).then(function (date) {
       if(date.length > 3) {
       $scope.date = date;
       }
       //alert(date);
       });*/


    };

    $scope.showError = function (msg) {
      $cordovaDialogs.alert(msg, 'Hiba', 'Ok');
    };

    $scope.meetsMinimumAge = function (birthDate, minAge) {
      var tempDate = new Date(birthDate.getFullYear() + minAge, birthDate.getMonth(), birthDate.getDate());
      return (tempDate <= new Date());
    };

    $scope.validateEmail = function (email) {
      var re = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
      return re.test(email);
    };

    $scope.register = function () {
      // Validálás:
      if ($scope.data.name == null) {
        $scope.showError("Kérjük adja meg a nevét!");
      } else if ($scope.data.mail == null) {
        $scope.showError("Kérjük adja meg az email címét!");
      } else if ($scope.validateEmail($scope.data.mail) == false) {
        $scope.showError("Kérjük adjon meg egy érvényes email címet!");
      } else if ($scope.data.password == null && $scope.data.id == null) {
        $scope.showError("Kérjük adjon meg egy jelszót!");
      } else if ($scope.data.password != $scope.data.passwordAgain && $scope.data.id == null) {
        $scope.showError("Nem egyezik meg a két jelszó!");
      } else if ($scope.data.date == null) {
        $scope.showError("Kérjük adja meg a születési dátumát!");
      } else if ($scope.meetsMinimumAge($scope.data.date, 18) == false) {
        $scope.showError("Csak 18 éven felüliek regisztrálhatnak!");
      } else if ($scope.data.aszf != true) {
        $scope.showError("Nem fogadta el az ÁSZF-et!");
      } else {
        if ($rootScope.isOnline) {
          $ionicLoading.show();
          $scope.api.post("register",
            {
              name: $scope.data.name,
              email: $scope.data.mail,
              password: $scope.data.password,
              facebook_id: $scope.data.id
            }, function (response) {
              if (response.data.success == false) {
                $cordovaDialogs.alert(response.data.message, 'Hiba', 'Ok');
              } else {
                // Sikeres regisztráció
                $cordovaDialogs.alert(response.data.message, 'Siker', 'Ok');

                // Lementjük a kapott tokent
                window.localStorage.setItem("token", response.data.data.token);

                window.localStorage.setItem("name", $scope.data.name);
                window.localStorage.setItem("email", $scope.data.mail);
                window.localStorage.setItem("profilePic", response.data.data.image);
                $rootScope.profilePic = response.data.data.image;
                window.localStorage.setItem("balance", 0);

                if (ionic.Platform.isAndroid()) {
                  $scope.registerAndroidPush(response.data.data.token);
                } else if (ionic.Platform.isIOS()) {
                  $scope.registerIOSPush(response.data.data.token);
                }

                $ionicLoading.hide();
                $state.go('tab.account', {state: 1});
              }
            });
        } else {
          $cordovaDialogs.alert("A regisztrációhoz internetkapcsolat szükséges!", 'Hiba', 'Ok');
        }
      }

    };

    $scope.registerIOSPush = function (token) {
      var iosConfig = {
        "badge": true,
        "sound": true,
        "alert": true,
      };
      document.addEventListener("deviceready", function () {
        $cordovaPush.register(iosConfig).then(function (deviceToken) {
          // Success -- send deviceToken to server, and store for future use
          //console.log("deviceToken: " + deviceToken);

          //$http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + deviceToken + "&type=ios")

          $scope.api.post("pushId", { token: token, pushIosToken: deviceToken, pushAndroidToken: "" }, function (response) {
            console.log(JSON.stringify(response));
          });

        }, function (err) {
          alert("Registration error: " + err);
        });
        $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
          if (notification.alert) {
            navigator.notification.alert(notification.alert);
          }

          if (notification.sound) {
            var snd = new Media(event.sound);
            snd.play();
          }

          if (notification.badge) {
            $cordovaPush.setBadgeNumber(notification.badge).then(function (result) {
              // Success!
            }, function (err) {
              // An error occurred. Show a message to the user
            });
          }
        });
        /*// WARNING! dangerous to unregister (results in loss of tokenID)
         $cordovaPush.unregister(iosConfig).then(function (result) {
         // Success!
         }, function (err) {
         // Error
         });*/
      }, false);
    };

    $scope.registerAndroidPush = function (token) {
      var androidConfig = {
        "senderID": "15325689404",
      };

      document.addEventListener("deviceready", function () {
        $cordovaPush.register(androidConfig).then(function (result) {
          // Success
        }, function (err) {
          // Error
        });

        $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
          switch (notification.event) {
            case 'registered':
              if (notification.regid.length > 0) {
                // Kiírja az ID-t midnen egyes idnításkor
                //alert('registration ID = ' + notification.regid);
                //$http.post("http://mobil.eclickapi.com/ke/Api.json?action=registerdevice&token=1&deviceid=" + notification.regid + "&type=android");
                $scope.api.post("pushId", { token: token, pushIosToken: "", pushAndroidToken: notification.regid }, function (response) {
                  console.log(JSON.stringify(response));
                });
              }
              break;

            case 'message':
              // this is the actual push notification. its format depends on the data model from the push server
              // Ha megnyitod az appot notification után akkor dobna egy alertet...
              // alert('message = ' + notification.message + ' msgCount = ' + notification.msgcnt);
              break;

            case 'error':
              alert('GCM error = ' + notification.msg);
              break;

            default:
              alert('An unknown GCM event has occurred');
              break;
          }
        });


        /*// WARNING: dangerous to unregister (results in loss of tokenID)
         $cordovaPush.unregister(options).then(function (result) {
         // Success!
         }, function (err) {
         // Error
         })*/
      }, false);
    };
    $scope.back = function () {
      $state.go('login');
    };

    $scope.aszf = function () {
      var link = "http://www.mobilutri.hu/aszf/";
      if (ionic.Platform.isIOS()) {
        link = "http://www.mobilutri.hu/aszf-ios/";
      }
      $cordovaInAppBrowser.open(link, '_blank');
    };

  });
