angular.module('SQL', [])

// DB wrapper
	.factory('DB', function ($q) {
		var self = this;
		self.db = db;

		self.query = function (query, bindings) {
			bindings = typeof bindings !== 'undefined' ? bindings : [];
			var deferred = $q.defer();

			self.db.transaction(function (transaction) {
				transaction.executeSql(query, bindings, function (transaction, result) {
					deferred.resolve(result);
				}, function (transaction, error) {
					deferred.reject(error);
				});
			});

			return deferred.promise;
		};

		self.fetchAll = function (result) {
			var output = [];

			for (var i = 0; i < result.rows.length; i++) {
				output.push(result.rows.item(i));
			}

			return output;
		};

		self.fetch = function (result) {
			return result.rows.item(0);
		};

		return self;
	})
	
// Resource service example
	.factory('Category', function (DB) {
		var self = this;

		self.all = function () {
			return DB.query('SELECT * FROM categories')
				.then(function (result) {
					return DB.fetchAll(result);
				});
		};

		self.getById = function (id) {
			return DB.query('SELECT * FROM categories WHERE categoryId = ?', [id])
				.then(function (result) {
					return DB.fetch(result);
				});
		};

		return self;
	})
	
	// Resource service example
	.factory('Week', function (DB) {
		var self = this;

		self.all = function () {
			return DB.query('SELECT * FROM weeks')
				.then(function (result) {
					return DB.fetchAll(result);
				});
		};
		
		self.letters = function () {
			return DB.query('SELECT letter_count FROM weeks')
				.then(function (result) {
					return DB.fetchAll(result);
				});
		};

		self.getById = function (id) {
			return DB.query('SELECT * FROM weeks WHERE weekId = ?', [id])
				.then(function (result) {
					return DB.fetch(result);
				});
		};

		return self;
	})
		// Resource service example
	.factory('Word', function (DB) {
		var self = this;

		self.match = function (word ) {
			return DB.query('SELECT * FROM words WHERE word = ?', [word])
				.then(function (result) {
					return DB.fetchAll(result);
				});
		};
		
		self.getById = function (id) {
			return DB.query('SELECT * FROM weeks WHERE weekId = ?', [id])
				.then(function (result) {
					return DB.fetch(result);
				});
		};

		return self;
	});